anew <<sort.f>>      \ 01jun02sam

code sort ( a n -- ) \ in place sorting of n-cell array
  push [ebp]         \ push array pointer a to return stack
  push ebx           \ push #cells n to return stack
  cmp  ebx , # 2     \ check if n>1
  jge  @@2           \ jump into loop, if true
  jmp  short @@3     \ otherwise, no need to sort
@@1:
  mov  eax , [ebx]   \ put current item a[0] at eax
  xchg eax , 4 [ebx] \ exchange eax with next item a[1]
  xchg eax , [ebx]   \ exchange eax with a[0] 
  cmp  eax , [ebx]   \ check if a[1]<a[0]
  jl   short @@1     \ loop back if true
  add  ebx , # 4     \ increment array pointer a
  loop @@1           \ loop back if n>0
@@2:
  pop  ecx           \ pop current n from return stack
  pop  ebx           \ pop current a from return stack
  push ebx           \ push current a to return stack
  dec  ecx           \ decrement n
  push ecx           \ push current n to return stack
  jg   short @@1     \ loop back if n>0
@@3:
  lea  esp , 8 [esp] \ pop current a and n from return stack
  mov  ebx , 4 [ebp] \ pop new top of data stack
  lea  ebp , 8 [ebp] \ reset data stack pointer
  ret                \ retuen to calling program
  end-code
  
(
  1 4 2 3 5 7 6 .s
  sp@ 7 sort .s
)
  