\ graphic operation

DECIMAL
: packxy     ( x y -- xy )                
	$FFFF AND SWAP $10 LSHIFT OR ;
: packrect   ( x1 y1 x2 y2 -- x1y1 x2y2 ) 
	packxy >R packxy R> ;
: unpackxy   ( xy -- x y )                
	DUP $10 RSHIFT SWAP $FFFF AND ;
: unpackrect ( x1y1 x2y2 -- x1 y1 x2 y2 ) 
	unpackxy >R >R unpackxy R> R> ;

 0
 4 -- g->op
 4 -- g->p1
 4 -- g->p2
 4 -- g->p3 
CONSTANT /GROP

$2000 CONSTANT MAXGROP
\ LATEST TO grop_end
$100 CONSTANT GROP.MOVETO
$101 CONSTANT GROP.LINETO
$102 CONSTANT GROP.RECT
$103 CONSTANT GROP.TEXTOUT
$104 CONSTANT GROP.ELLIPSE
$105 CONSTANT GROP.DOT
$106 CONSTANT GROP.PENCOLOR
$107 CONSTANT GROP.BRUSHCOLOR
$108 CONSTANT GROP.TEXTCOLOR
$109 CONSTANT GROP.TEXTBG
$10A CONSTANT GROP.SETFONT
$11B CONSTANT GROP.PENMODE
$11C CONSTANT GROP.BITMAP
$11D CONSTANT GROP.BORDER
$11E CONSTANT GROP.RRECT       \ round rect
$11F CONSTANT GROP.RTEXTOUT    \ rect text
$120 CONSTANT GROP.SYSBMP
\ LATEST TO grop_start

0 VALUE grops
0 VALUE #grop

: /g 			/GROP * grops + ;
: g# 			#grop /g ;
: g.op  ( g -- op )     g->op @ ;
: g.p1  ( g -- p1 )     g->p1 @ ;
: g.p2  ( g -- p2 )     g->p2 @ ;
: g.p1&2 ( g -- p1 p2 ) DUP g->p2 @ SWAP g->p1 @ ;
: g.p3  ( g -- p3 )     g->p3 @ ;

: addgrop ( p1 p2 p3 op -- )
  	#grop MAXGROP 1- > 
	IF 2DROP 2DROP EXIT THEN     \ not allow to add
  	g# g->op ! 
  	g# g->p3 ! 
  	g# g->p2 ! 
  	g# g->p1 ! 
  	#grop 1+ TO #grop		\ add grop
	;                              

: 0para:
  	CREATE ,
  	DOES> R> 0 0 0 addgrop ;

: 1para:
  	CREATE  ,    \ op
  	DOES> R> @ >R 0 0 R> addgrop ;
    
: 2para:
  	CREATE  ,    \ op
  	DOES> R> @ >R 0 R> addgrop ;

: 3para:
  	CREATE  ,    \ op
  	DOES> R> @ addgrop ;

GROP.MOVETO     2para: gMOVETO  ( x y -- )
GROP.LINETO     2para: gLINETO  ( x y -- )
GROP.RECT       2para: gRECT    ( x1y1 x2y2 -- )
GROP.RRECT      2para: gRRECT   ( x1y1 x2y2 -- )
GROP.BORDER     2para: gBORDER  ( x1y1 x2y2 -- )
GROP.DOT        2para: gDOT     ( x y -- )
GROP.ELLIPSE    2para: gELLIPSE ( x1y1 x2y2 -- )
GROP.TEXTOUT    3para: gTEXTOUT ( x1y1 text len  -- )
GROP.PENMODE    1para: gPENMODE
GROP.RTEXTOUT   3para: gRTEXTOUT ( x1y1 x2y2 ztext -- )

GROP.PENCOLOR   1para: gPENCOLOR
GROP.BRUSHCOLOR 1para: gBRUSHCOLOR
GROP.TEXTCOLOR  1para: gTEXTCOLOR
GROP.TEXTBG     1para: gTEXTBG
GROP.SETFONT    1para: gSETFONT
GROP.BITMAP     3para: gBITMAP ( x1y1 x2y2 HIMAGE -- )
GROP.SYSBMP     3para: gSYSBMP ( x1y1 x2y2 CONST -- )

: INITGROP
  	HERE TO grops
  	/GROP MAXGROP * ALLOT
	;

