anew <<predefine.f>>

hidden

: -- create over , + does> r> @ + ;

CREATE aFile $100 ALLOT
CREATE eFMLfile $80 ALLOT
CREATE FileStack $1000 ALLOT
CREATE FileBuffer $100000 ALLOT
VARIABLE FilePointer 
VARIABLE FileSize
VARIABLE FileStackPointer
VARIABLE hFile

: initFileStack
	FileStack FileStackPointer !
	FileStack $1000 0 FILL 
	FileBuffer 0 FileStack 2! ;
initFileStack

: pushFileStack ( -- )
	FileStackPointer @ 2@ + 0
	8 FileStackPointer +!
	FileStackPointer @ 2! ;

: popFileStack
	FileStackPointer @ 8 -
	FileStack <
	IF initFileStack 
	ELSE -8 FileStackPointer +!
	THEN ;

: LoadFile ( cstr -- b # )
	1+ ( zstr ) hOpen hFile !
      	hFile @ 
      	FileStackPointer @ 2@ DROP $10000
	hRead
      	0= ABORT" load file error" 
      	FileStackPointer @ 2@ DROP
	#ByteRead FileStackPointer @ 2!
   	hFile @ CloseHandle 
      	0= ABORT" close file error" 
      	FileStackPointer @ 2@ ( b # )
   	;

: EVALUATE ( b # -- )
	#TIB 2@ >R >R >IN @ >R
	#TIB 2! 0 >IN !
	EVAL
	R> >IN ! R> R> #TIB 2!
	;		

: NEW-FLOAD ( <filename> )
	pushFileStack
	BL WORD CR ." Loading... " DUP COUNT TYPE
	LoadFile ( b # ) EVALUATE
	popFileStack
	;

: \ 	$0A WORD DROP ; IMMEDIATE

: ALIGN ( -- )
	HERE 3 AND ?DUP
	IF 4 SWAP - ALLOT THEN
	;

: FILE ( u # -- a n )
	DROP 1+
	pushFileStack
	LoadFile ( b # ) 
	popFileStack
	;

only

: >UPPER   ( $a u -- )
	FOR AFT
		DUP C@
		DUP $007B <
		IF DUP $060 >
			IF $0020 - THEN
		THEN
		OVER C!  1+
	THEN NEXT 
	DROP ;

: SEARCH1 \ (  c-addr u char -- (pos) t/f )
	ROT DUP >R ROT			( save c-addr )
	FOR AFT	OVER OVER 		( char addr char addr -- )
		C@ =
		IF	SWAP R> 2DROP	( found char )
			R> SWAP - -1 EXIT
		ELSE	1+		( next char )
		THEN
	THEN NEXT 
	2DROP 				( not found, discard char and addr )
	R> 0				( leave addr and 0 )
	;

: compare? ( addr1 addr2 u -- f )
	FOR AFT OVER C@ OVER C@ -	( compare each char )
		IF 2DROP R> DROP 0 EXIT THEN	( not the same )
		1+ SWAP 1+ SWAP		( move to next char )
	THEN NEXT
	2DROP -1 			( strings are the same )
	;

( Leave c-addr1 on the stack to be c-addr3 )
( Inside FOR-NEXT loop, c-addr3 is on data stack, u3 on return stack. )
( This is a happy and rare occassion that loop index matches an output parameter. )
( Use only c-addr2 and u2 as local input variables )
0 VALUE c-addr2
0 VALUE u2
: SEARCH ( c-addr1 u1 c-addr2 u2 -- c-addr3 u3 flag )
	TO u2 TO c-addr2
	DUP u2 < IF 0 EXIT THEN 	( u1<u2, never a match )
	OVER >R 			( save c-addr1 )
	DUP ( u1 ) >R			( save u1 )
	( u1 ) FOR AFT 			( c-addr3 )
		DUP c-addr2 u2 compare?	( compare string3 and string2 )
		IF 	R> -1 		( c-addr3 u3 flag ) 
			R> R> 2DROP 	( discard c-addr1 and u1 )
			EXIT		( found match )
		ELSE	1+ 		( next c-addr3 )
		THEN
	THEN NEXT
	DROP 				( discard c-addr3 )
	R> R> 				( c-addr1 u1 )
	0 				( flag, failed to match )
	;	
0 value CodeSize
: INVERT NOT ;
16    VALUE LASTFONTSIZE
0 VALUE thisFONT.size
0 value ccg16_header
0 value ccg16_milestone
0 value ccg16_body
0 value INITSCREEN 
0 value Z-COUNT 
\ ' (MyCB) WNDPROC: MyCB
: HALT BYE ;

: U-COUNT (  c-addr -- c-addr u )
   	DUP
   	BEGIN  DUP C@
   	WHILE  2+
   	REPEAT OVER -
	;

