\  TLOCALS.F   Local variables
\  Parent:  (c)Andrey Cherezov RU FIG, 2000
\       An ideas of the following authors had been used:
\       Ruvim Pinka; Dmitry Yakimov; Oleg Shalyopa;
\       Yuriy Zhilovets; Konstantin Tarasov
\  ~1001bytes, 2001

VOCABULARY vTloc

GET-CURRENT ALSO vTloc DEFINITIONS

VARIABLE widLoc
VARIABLE uPCurr
VARIABLE _lc
VARIABLE _ilc  \ i-locals counter
VARIABLE _ulc  \ n-locals counter
VARIABLE _olc  \ o-locals counter

\ #IFNDEF LP+@
  : LP+@ S0 @ SWAP - @ ;
\ #ENDIF
\ #IFNDEF LP@
  : LP@ S0 @ ;
\ #ENDIF
\ #IFNDEF LP+!
: LP+! S0 @ SWAP - ! ;
\ #ENDIF

: LP+  S0 @ SWAP - ;

: LP@+! S0 @ SWAP - DUP @ ROT + SWAP ! ;
: LP@-! S0 @ SWAP - DUP @ ROT - SWAP ! ;

\ #IFNDEF [ep]
: [ep] ( _olc --)
  S0 @ SWAP - SP!
  R> R> S0 ! >R
;
\ #ENDIF

\ #IFNDEF [pr]
: [pr] ( _ulc _ilc -- )
  R> S0 @ >R >R
  SP@ + 8 + S0 !
  SP@ 4 + SWAP - SP!
;
\ #ENDIF

: [Epilog]
  _olc @ 2 LSHIFT LIT,
  POSTPONE [ep]
  ;

: [Prolog]
  uPCurr @ SET-CURRENT
  _ulc @ 2 LSHIFT LIT,
  _ilc @ 2 LSHIFT LIT,
  POSTPONE [pr]
;

: CompileLocal@ ( n -- )
  LIT, POSTPONE LP+@
;
: LocalsStartup
  TEMP-WORDLIST widLoc  !
  GET-CURRENT uPCurr !
  ALSO vTloc
  ALSO widLoc @ CONTEXT ! DEFINITIONS
  _ilc 0! _lc  0!
  _ulc 0! _olc 0!
;
: LocalsCleanup
  PREVIOUS PREVIOUS
  widLoc @ FREE-WORDLIST
;
: LocalsDoes@
  DUP @ 1+ 2 LSHIFT , 1+!
  DOES> @ CompileLocal@
;
: ;; POSTPONE ; ; IMMEDIATE
: ^ '  >BODY @ LIT, POSTPONE LP+ ; IMMEDIATE
: -> ' >BODY @ LIT, POSTPONE LP+! ; IMMEDIATE
: == ' >BODY @ LIT, POSTPONE LP+! ; IMMEDIATE
: += ' >BODY @ LIT, POSTPONE LP@+! ; IMMEDIATE
: -= ' >BODY @ LIT, POSTPONE LP@-! ; IMMEDIATE

WARNING @ WARNING 0!
: EXIT [Epilog]  RET, ; IMMEDIATE
: ;  LocalsCleanup [Epilog] POSTPONE ; ; IMMEDIATE

WARNING !

\ =====================================================================
SET-CURRENT

: {
 LocalsStartup
    BEGIN   BL SKIP PeekChar DUP [CHAR] \ <>
            SWAP [CHAR] - <> AND
    WHILE   CREATE _lc LocalsDoes@ IMMEDIATE _ilc 1+!
    REPEAT

 PeekChar >IN 1+! [CHAR] \ =
 IF BEGIN   BL SKIP PeekChar [CHAR] - <>
    WHILE   CREATE _lc LocalsDoes@ IMMEDIATE _ulc 1+!
    REPEAT
 THEN

 [CHAR] - SKIP

    BEGIN    BL SKIP PeekChar [CHAR] } <>
    WHILE    CREATE _olc LocalsDoes@ IMMEDIATE
    REPEAT   >IN 1+!

  _olc @ _ilc @ _ulc @ + > IF _olc @ _ulc ! THEN
   [Prolog]
;; IMMEDIATE

PREVIOUS




